import { Edge, Node } from '@graphpolaris/shared/lib/data-access';
import { dataColors, tailwindColors } from 'config';
import { Graphics, Sprite, Texture } from 'pixi.js';

export const createColumn = (
  id: number,
  nodesCol: Node[],
  nodesRow: Node[],
  edges: Edge[],
  colorScale: any,
  cellWidth: number,
  cellHeight: number
) => {
  // console.log('createColumn', id, nodes.length, edges.length);
  const sprite = new Sprite(Texture.WHITE);
  sprite.name = 'col_' + id;
  sprite.eventMode = 'static';
  // button.eventMode = 'static';
  sprite.cursor = 'pointer';
  const edgesForThisColumn = edges.filter((edge) => {
    return edge.from === nodesCol[id].id || edge.to === nodesCol[id].id;
  });
  // console.log('edgesForThisColumn', nodesCol[id].id, edgesForThisColumn);
  // const color = new Color({ r: 255 * (id / nodesCol.length), g: 255, b: 255, a: 1 });
  const bgCellColor = dataColors.neutral['5'];
  const fgCellColor = tailwindColors.entity.DEFAULT;
  let color = bgCellColor;
  for (let i = 0; i < nodesRow.length; i++) {
    const node = nodesRow[i];
    if (
      edgesForThisColumn.filter((edge) => {
        return edge.from === node.id || edge.to === node.id;
      }).length > 0
    ) {
      color = fgCellColor;
    } else {
      color = bgCellColor;
    }
    sprite.tint = color;
    sprite.width = cellWidth;
    sprite.height = cellHeight;
    sprite.position.set(id * cellHeight, i * cellWidth);
    // sprite.acceleration = new Point(0);
    // TODO get
    // gfx.beginFill(colorScale(node.type)));
    // sprite.lineStyle(2, 0xffffff);
    // sprite.drawRect(0, i * cellWidth, cellWidth, cellHeight);
    // sprite.endFill();
  }
  //   sprite.on('pointerdown', onButtonDown);
  // .on('pointerup', onDragEnd).on('pointerupoutside', onDragEnd);
  // for (let i = 0; i < edges.length; i++) {
  //   const edge = edges[i];
  //   // draw an rectangle with a fill
  //   gfx.beginFill(0xff0000, 0.5);
  //   gfx.drawRect(0, i * cellWidth, cellWidth, cellHeight * nodes.length);
  //   gfx.endFill();
  // }
  return sprite;
};
